/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.tutorial.web;


import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * NGXgp[^̃GR[fBOݒsB
 * <p/>
 * ServletAPIo[W2.3ȏɂėLB<br>
 * L̂悤web.xmlɐݒ肷B
 * <p/>
 * &nbsp;&nbsp;&lt;filter&gt;<br>
 * &nbsp;&nbsp;&nbsp;
 * &lt;filter-name&gt;encodingFilter&lt;/filter-name&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;filter-class&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
 * jp.terasoluna.sample.web.SetCharacterEncodingFilter<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;/filter-class&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;init-param&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
 * &lt;param-name&gt;encoding&lt;/param-name&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
 * &lt;param-value&gt;Windows-31J&lt;/param-value&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;/init-param&gt;<br>
 * &nbsp;&nbsp;&lt;/filter&gt;<br>
 * &nbsp;&nbsp;&lt;filter-mapping&gt;<br>
 * &nbsp;&nbsp;&nbsp;
 * &lt;filter-name&gt;encodingFilter&lt;/filter-name&gt;<br>
 * &nbsp;&nbsp;&nbsp;&nbsp;&lt;url-pattern&gt;/*&lt;/url-pattern&gt;<br>
 * &nbsp;&nbsp;&lt;/filter-mapping&gt;<br>
 * <p/>
 *
 */
public class SetCharacterEncodingFilter implements Filter {

    /**
     * ONX
     */
    private static Log log =
        LogFactory.getLog(SetCharacterEncodingFilter.class);

    /**
     * GR[fBOB
     */
    protected String encoding = null;

    /**
     * tB^[RtBOB
     */
    protected FilterConfig filterConfig = null;

    /**
     * NCAgŎw肳ꂽGR[fBO𖳎邩ǂ̃tOB
     */
    protected boolean ignore = true;

    /**
     * IB
     */
    public void destroy() {
        this.encoding = null;
        this.filterConfig = null;

    }

    /**
     * tB^[B
     * NGXgp[^w肳ꂽGR[fBOɐݒ肷B
     *
     * @param request NGXg
     * @param response X|X
     * @param chain tB^[`F[
     * @exception IOException IOO
     * @exception ServletException O
     */
    public void doFilter(ServletRequest request, ServletResponse response,
        FilterChain chain) throws IOException, ServletException {

        if (log.isDebugEnabled()) {
            log.debug("doFilter() called");
        }

        if (ignore || (request.getCharacterEncoding() == null)) {
            String encoding = selectEncoding(request);
            if (encoding != null) {
                request.setCharacterEncoding(encoding);
            }
        }
        chain.doFilter(request, response);
    }


    /**
     * B
     *
     * @param filterConfig tB^[ݒ
     * @exception ServletException O
     */
    public void init(FilterConfig filterConfig) throws ServletException {

        if (log.isDebugEnabled()) {
            log.debug("init() called.");
        }

        this.filterConfig = filterConfig;
        this.encoding = filterConfig.getInitParameter("encoding");
        if (log.isDebugEnabled()) {
            log.debug("this.encoding = " + this.encoding);
        }

        String value = filterConfig.getInitParameter("ignore");
        if (value == null) {
            this.ignore = true;
        } else if ("true".equalsIgnoreCase(value)) {
            this.ignore = true;
        } else if ("yes".equalsIgnoreCase(value)) {
            this.ignore = true;
        } else {
            this.ignore = false;
        }
    }

    /**
     * GR[fBOIB
     *
     * @param request NGXg
     * @return GR[fBO
     */
    protected String selectEncoding(ServletRequest request) {
        return this.encoding;
    }

}
